import { CreateOrganizationMemberCommand } from '@nestjs-bff/global-contracts/lib/application/auth/create-organization-member.command';
import { AccessPermissionsContract } from '@nestjs-bff/global-contracts/lib/domain/access-permissions/access-permissions.contract';
import { AccessPermissionsEntity } from '../../domain/access-permissions/model/access-permissions.entity';
import { AccessPermissionsRepo } from '../../domain/access-permissions/repo/access-permissions.repo';
import { AuthenticationRepo } from '../../domain/authentication/repo/authentication.repo';
import { OrganizationRepo } from '../../domain/organization/repo/organization.repo';
import { UserRepo } from '../../domain/user/repo/user.repo';
import { LoggerSharedService } from '../../shared/logging/logger.shared.service';
export declare class OrganizationOrchestrationService {
    private readonly logger;
    private readonly authenticationRepo;
    private readonly accessPermissionsRepo;
    private readonly userRepo;
    private readonly organizationRepo;
    private orgAdminAuthCheck;
    constructor(logger: LoggerSharedService, authenticationRepo: AuthenticationRepo, accessPermissionsRepo: AccessPermissionsRepo, userRepo: UserRepo, organizationRepo: OrganizationRepo);
    createMember(cmd: CreateOrganizationMemberCommand, accessPermissions?: AccessPermissionsContract): Promise<AccessPermissionsEntity>;
}
//# sourceMappingURL=organization-orchestration.service.d.ts.map