import { LocalAuthenticateCommand } from '@nestjs-bff/global-contracts/lib/application/auth/local-authenticate.command';
import { LocalRegisterCommand } from '@nestjs-bff/global-contracts/lib/application/auth/local-register.command';
import { PromoteToGroupAdminCommand } from '@nestjs-bff/global-contracts/lib/application/auth/promote-to-group-admin.command';
import { AccessPermissionsContract } from '@nestjs-bff/global-contracts/lib/domain/access-permissions/access-permissions.contract';
import { AccessPermissionsEntity } from '../../domain/access-permissions/model/access-permissions.entity';
import { AccessPermissionsRepo } from '../../domain/access-permissions/repo/access-permissions.repo';
import { AuthenticationRepo } from '../../domain/authentication/repo/authentication.repo';
import { FacebookAuthenticationService } from '../../domain/authentication/social/facebook-authentication.service';
import { FacebookProfileService } from '../../domain/authentication/social/facebook-profile..service';
import { OrganizationRepo } from '../../domain/organization/repo/organization.repo';
import { UserRepo } from '../../domain/user/repo/user.repo';
export declare class UserAuthService {
    private readonly fbAuthenticationService;
    private readonly fbProfileService;
    private readonly authenticationRepo;
    private readonly accessPermissionsRepo;
    private readonly userRepo;
    private readonly organizationRepo;
    constructor(fbAuthenticationService: FacebookAuthenticationService, fbProfileService: FacebookProfileService, authenticationRepo: AuthenticationRepo, accessPermissionsRepo: AccessPermissionsRepo, userRepo: UserRepo, organizationRepo: OrganizationRepo);
    /**
     *
     * @param cmd
     */
    signInWithLocal(cmd: LocalAuthenticateCommand): Promise<AccessPermissionsEntity>;
    /**
     *
     * @param cmd
     */
    signUpWithLocal(cmd: LocalRegisterCommand): Promise<AccessPermissionsEntity>;
    /**
     *
     * @param cmd
     */
    promoteToGroupAdmin(cmd: PromoteToGroupAdminCommand, accessPermissions: AccessPermissionsContract): Promise<AccessPermissionsEntity>;
    /**
     *
     * @param fbAuthorizationCode
     * @param spaRootUrl
     */
    signUpWithFacebook(fbAuthorizationCode: string, spaRootUrl: string): Promise<AccessPermissionsEntity>;
    /**
     *
     * @param fbAuthorizationCode
     * @param spaRootUrl
     */
    signInWithFacebook(fbAuthorizationCode: string, spaRootUrl: string): Promise<AccessPermissionsEntity>;
}
//# sourceMappingURL=user-auth.service.d.ts.map