import { INestjsBffConfigEnv } from './nestjs.config.env.interface';
declare const _NestjsBffConfig: {
    orgName: string;
    appName: string;
    rootPath: string;
    caching: {
        entities: {
            organization: number;
            user: number;
            authorization: number;
        };
    };
    migrations: {
        autoRun: boolean;
    };
    db: {
        mongo: {
            debugLogging: boolean;
            options: {
                useNewUrlParser: boolean;
                useCreateIndex: boolean;
                useFindAndModify: boolean;
                autoIndex: boolean;
                reconnectTries: number;
                reconnectInterval: number;
                poolSize: number;
                bufferMaxEntries: number;
                connectTimeoutMS: number;
                socketTimeoutMS: number;
                family: number;
            };
        };
    };
    http: {
        publicRouteRegex: RegExp;
    };
    jwt: {
        jwtPrivateKey: string;
        jwtPrivateKeyPemPassphrase: string;
        jwtPublicKey: string;
        issuer: string;
        expiresIn: string;
        signingAlgorithm: string;
    };
    logging: {
        logDir: string;
        console: {
            levels: string[];
        };
        winston: {
            level: string;
            enableMiddleware: boolean;
            transports: {
                console: {
                    colorize: boolean;
                    timestamp: boolean;
                    json: boolean;
                    showLevel: boolean;
                };
                file: {
                    json: boolean;
                    maxsize: number;
                    maxfile: number;
                };
            };
            target: {
                trace: string;
                debug: string;
                error: string;
                warn: string;
                info: string;
            };
        };
    };
    social: {
        facebook: {
            authorizeHost: string;
            tokenHost: string;
            apiHost: string;
            authorizePath: string;
            authorizeScope: string[];
            tokenPath: string;
            apiProfilePath: string;
            callbackRelativeURL_signIn: string;
            callbackRelativeURL_signUp: string;
        };
    };
};
export declare type INestjsBffConfig = typeof _NestjsBffConfig & INestjsBffConfigEnv;
export declare const NestjsBffConfig: INestjsBffConfig;
export {};
//# sourceMappingURL=nestjs-bff.config.d.ts.map