"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const key_shared_utils_1 = require("../shared/utils/key.shared.utils");
exports.NestjsBffConfigEnv = {
    nodeEnv: 'test',
    db: {
        mongo: {
            mongoConnectionUri: 'mongodb://localhost',
            options: {
                dbName: 'my-nestjs-bff-app-e2e',
            },
        },
    },
    http: {
        bffDomain: 'localhost',
        bffPort: 1337,
        get bffRootUrl() {
            return `http://${this.bffDomain}:${this.bffPort}`;
        },
        spaDomain: 'localhost',
        spaPort: 4200,
        get spaRootUrl() {
            return `http://${this.spaDomain}:${this.spaPort}`;
        },
    },
    social: {
        facebook: {
            clientID: 'your-secret-clientID-here',
            clientSecret: 'your-client-secret-here',
        },
    },
    jwt: {
        jwtPrivateKey: key_shared_utils_1.extractKey(`${process.cwd()}\\src\\config\\keys\\jwt.private-key.test.pem`),
        jwtPublicKey: key_shared_utils_1.extractKey(`${process.cwd()}\\src\\config\\keys\\jwt.public-key.test.pem`),
    },
};
//# sourceMappingURL=nestjs.config.test.js.map