"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const mongoose_1 = require("mongoose");
const app_shared_constants_1 = require("../../../shared/app/app.shared.constants");
const caching_shared_constants_1 = require("../../../shared/caching/caching.shared.constants");
const logger_shared_service_1 = require("../../../shared/logging/logger.shared.service");
const base_repo_1 = require("../../core/repo/base.repo");
const class_validator_1 = require("../../core/validators/class-validator");
const foo_constants_1 = require("../foo.constants");
const foo_entity_1 = require("../model/foo.entity");
let FooRepo = class FooRepo extends base_repo_1.BaseRepo {
    constructor(loggerService, nestjsBffConfig, cacheStore, model) {
        super({
            loggerService,
            cacheStore,
            defaultTTL: 60 * 1,
            model,
            entityValidator: new class_validator_1.ClassValidator(loggerService, foo_entity_1.FooEntity),
        });
        this.loggerService = loggerService;
    }
    generateValidQueryConditionsForCacheClear(entity) {
        return [{ id: entity.id, userId: entity.userId, orgId: entity.orgId }];
    }
};
FooRepo = __decorate([
    common_1.Injectable(),
    __param(1, common_1.Inject(app_shared_constants_1.AppSharedProviderTokens.Config.App)),
    __param(2, common_1.Inject(caching_shared_constants_1.CachingProviderTokens.Services.CacheStore)),
    __param(3, common_1.Inject(foo_constants_1.FooProviderTokens.Models.Foo)),
    __metadata("design:paramtypes", [logger_shared_service_1.LoggerSharedService, Object, Object, mongoose_1.Model])
], FooRepo);
exports.FooRepo = FooRepo;
//# sourceMappingURL=foo.repo.js.map