"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const roles_constants_1 = require("@nestjs-bff/global-contracts/lib/shared/authorization/roles.constants");
const base_entity_1 = require("@nestjs-bff/global-contracts/lib/domain/core/base.entity");
const class_validator_1 = require("class-validator");
class AccessPermissionsEntity extends base_entity_1.BaseEntity {
    constructor() {
        super(...arguments);
        this.roles = [roles_constants_1.Roles.user];
        this.organizations = [];
    }
}
__decorate([
    class_validator_1.IsNotEmpty(),
    __metadata("design:type", String)
], AccessPermissionsEntity.prototype, "userId", void 0);
__decorate([
    class_validator_1.IsArray(),
    class_validator_1.IsIn([roles_constants_1.Roles.user, roles_constants_1.Roles.groupAdmin, roles_constants_1.Roles.staffAdmin, roles_constants_1.Roles.systemAdmin], { each: true }),
    __metadata("design:type", Array)
], AccessPermissionsEntity.prototype, "roles", void 0);
__decorate([
    class_validator_1.ValidateNested(),
    __metadata("design:type", Array)
], AccessPermissionsEntity.prototype, "organizations", void 0);
exports.AccessPermissionsEntity = AccessPermissionsEntity;
class OrganizationAuthorization {
    constructor() {
        this.organizationRoles = [];
    }
}
__decorate([
    class_validator_1.IsBoolean(),
    __metadata("design:type", Boolean)
], OrganizationAuthorization.prototype, "primary", void 0);
__decorate([
    class_validator_1.IsNotEmpty(),
    __metadata("design:type", String)
], OrganizationAuthorization.prototype, "orgId", void 0);
__decorate([
    class_validator_1.IsArray(),
    class_validator_1.IsIn([roles_constants_1.OrganizationRoles.member, roles_constants_1.OrganizationRoles.admin], { each: true }),
    __metadata("design:type", Array)
], OrganizationAuthorization.prototype, "organizationRoles", void 0);
exports.OrganizationAuthorization = OrganizationAuthorization;
//# sourceMappingURL=access-permissions.entity.js.map