"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const roles_constants_1 = require("@nestjs-bff/global-contracts/lib/shared/authorization/roles.constants");
const mongoose_1 = require("mongoose");
const UserOrgPermissionsSchema = new mongoose_1.Schema({
    primary: {
        type: mongoose_1.Schema.Types.Boolean,
        required: true,
    },
    orgId: {
        type: mongoose_1.Schema.Types.ObjectId,
        required: false,
    },
    organizationRoles: {
        type: [mongoose_1.Schema.Types.String],
        enum: [roles_constants_1.OrganizationRoles.member, roles_constants_1.OrganizationRoles.admin, roles_constants_1.OrganizationRoles.facilitator],
        required: true,
    },
});
exports.AccessPermissionsSchema = new mongoose_1.Schema({
    userId: {
        type: mongoose_1.Schema.Types.ObjectId,
        required: false,
    },
    roles: {
        type: [mongoose_1.Schema.Types.String],
        enum: [roles_constants_1.Roles.user, roles_constants_1.Roles.groupAdmin, roles_constants_1.Roles.systemAdmin],
        required: true,
    },
    organizations: {
        type: [UserOrgPermissionsSchema],
        required: true,
    },
}, {
    timestamps: true,
    collection: 'accesspermissions',
});
//# sourceMappingURL=access-permissions.schema.js.map