"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const mongo_shared_constants_1 = require("../../shared/database/mongo/mongo.shared.constants");
const core_module_1 = require("../core/core.module");
const authentication_constants_1 = require("./authentication.constants");
const authentication_schema_1 = require("./model/authentication.schema");
const authentication_repo_1 = require("./repo/authentication.repo");
const facebook_authentication_service_1 = require("./social/facebook-authentication.service");
const facebook_client_service_1 = require("./social/facebook-client.service");
const facebook_profile__service_1 = require("./social/facebook-profile..service");
const AuthenticationModel = {
    provide: authentication_constants_1.AuthenticationProviderTokens.Models.Authentication,
    useFactory: mongoose => mongoose.connection.model('Authentication', authentication_schema_1.AuthenticationSchema),
    inject: [mongo_shared_constants_1.MongoSharedProviderTokens.Connections.Mongoose],
};
let DomainAuthenticationModule = class DomainAuthenticationModule {
};
DomainAuthenticationModule = __decorate([
    common_1.Module({
        imports: [core_module_1.DomainCoreModule],
        providers: [
            authentication_repo_1.AuthenticationRepo,
            authentication_repo_1.AuthenticationRepo,
            facebook_client_service_1.FacebookClientService,
            facebook_profile__service_1.FacebookProfileService,
            facebook_authentication_service_1.FacebookAuthenticationService,
            AuthenticationModel,
        ],
        exports: [authentication_repo_1.AuthenticationRepo, facebook_authentication_service_1.FacebookAuthenticationService, facebook_profile__service_1.FacebookProfileService],
    })
], DomainAuthenticationModule);
exports.DomainAuthenticationModule = DomainAuthenticationModule;
//# sourceMappingURL=authentication.module.js.map