"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
exports.AuthenticationSchema = new mongoose_1.Schema({
    userId: {
        type: mongoose_1.Schema.Types.ObjectId,
        required: true,
    },
    local: {
        email: { type: String, lowercase: true, unique: true, sparse: true },
        hashedPassword: String,
    },
    google: {
        id: String,
        accessToken: String,
        email: String,
        name: String,
    },
    facebook: {
        id: String,
        accessToken: String,
        name: String,
        email: String,
    },
    twitter: {
        id: String,
        accessToken: String,
        displayName: String,
        username: String,
    },
}, {
    timestamps: true,
    collection: 'authentication',
});
//# sourceMappingURL=authentication.schema.js.map