"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const axios_1 = require("axios");
const crypto_1 = require("crypto");
const app_shared_constants_1 = require("../../../shared/app/app.shared.constants");
const logger_shared_service_1 = require("../../../shared/logging/logger.shared.service");
let FacebookClientService = class FacebookClientService {
    constructor(nestjsBffConfig, bffLoggerService) {
        this.nestjsBffConfig = nestjsBffConfig;
        this.bffLoggerService = bffLoggerService;
    }
    get(getRequest, accessToken) {
        return __awaiter(this, void 0, void 0, function* () {
            // Secure API call by adding proof of the app secret.  This is required when
            // the "Require AppSecret Proof for Server API calls" setting has been
            // enabled.  The proof is a SHA256 hash of the access token, using the app
            // secret as the key.
            //
            // For further details, refer to:
            // https://developers.facebook.com/docs/reference/api/securing-graph-api/
            const proof = crypto_1.createHmac('sha256', this.nestjsBffConfig.social.facebook.clientSecret)
                .update(accessToken.token)
                .digest('hex');
            this.bffLoggerService.debug('FacebookClientService-get-nestjsBffConfig', this.nestjsBffConfig);
            // Get profile data
            const getRequestWithAuth = `${this.nestjsBffConfig.social.facebook.apiHost}` + getRequest + `&access_token=${accessToken.token}` + `&appsecret_proof=${proof}`;
            // Submit request
            this.bffLoggerService.debug('FacebookClientService-get-getRequestWithAuth', getRequestWithAuth);
            const result = yield axios_1.default.get(getRequestWithAuth);
            this.bffLoggerService.debug('FacebookClientService-get-result.data', result.data);
            return result.data;
        });
    }
};
FacebookClientService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(app_shared_constants_1.AppSharedProviderTokens.Config.App)),
    __metadata("design:paramtypes", [Object, logger_shared_service_1.LoggerSharedService])
], FacebookClientService);
exports.FacebookClientService = FacebookClientService;
//# sourceMappingURL=facebook-client.service.js.map