"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const app_shared_constants_1 = require("../../../shared/app/app.shared.constants");
const app_exception_1 = require("../../../shared/exceptions/app.exception");
const logger_shared_service_1 = require("../../../shared/logging/logger.shared.service");
const facebook_client_service_1 = require("./facebook-client.service");
let FacebookProfileService = class FacebookProfileService {
    constructor(nestjsBffConfig, bffLoggerService, facebookClientService) {
        this.nestjsBffConfig = nestjsBffConfig;
        this.bffLoggerService = bffLoggerService;
        this.facebookClientService = facebookClientService;
    }
    getProfile(accessToken) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                // Get profile data
                const fbGetRequest = `${this.nestjsBffConfig.social.facebook.apiProfilePath}?fields=id,first_name,last_name,email`;
                const fbProfileResponse = yield this.facebookClientService.get(fbGetRequest, accessToken);
                const result = {
                    id: fbProfileResponse.id,
                    email: fbProfileResponse.email,
                    name: `${fbProfileResponse.last_name} ${fbProfileResponse.last_name}`,
                };
                this.bffLoggerService.debug('FacebookProfileService.getProfile.result', result);
                return result;
            }
            catch (error) {
                this.bffLoggerService.error('Error retrieving Facebook profile data', error);
                throw new app_exception_1.AppError('There was a problem accessing Facebook information during authentication');
            }
        });
    }
};
FacebookProfileService = __decorate([
    common_1.Injectable(),
    __param(0, common_1.Inject(app_shared_constants_1.AppSharedProviderTokens.Config.App)),
    __metadata("design:paramtypes", [Object, logger_shared_service_1.LoggerSharedService,
        facebook_client_service_1.FacebookClientService])
], FacebookProfileService);
exports.FacebookProfileService = FacebookProfileService;
//# sourceMappingURL=facebook-profile..service.js.map