"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const validation_exception_1 = require("../../../shared/exceptions/validation.exception");
const authentication_repo_1 = require("../repo/authentication.repo");
const messages_constants_1 = require("./messages.constants");
let DeprecatedAuthenticationCreateValidator = class DeprecatedAuthenticationCreateValidator {
    constructor(authenticationRepo) {
        this.authenticationRepo = authenticationRepo;
    }
    validate(authenticationEntity, options) {
        return __awaiter(this, void 0, void 0, function* () {
            const messages = [];
            if (!options || !options.skipUserIdValidation) {
                if (!authenticationEntity.userId)
                    messages.push(messages_constants_1.Messages.USER_ID_REQUIRED);
            }
            if (authenticationEntity.local) {
                if (yield this.authenticationRepo.findOne({ local: { email: authenticationEntity.local.email } })) {
                    messages.push(messages_constants_1.Messages.EMAIL_IN_USE);
                }
            }
            if (messages.length > 0)
                throw new validation_exception_1.ValidationError(messages);
        });
    }
};
DeprecatedAuthenticationCreateValidator = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [authentication_repo_1.AuthenticationRepo])
], DeprecatedAuthenticationCreateValidator);
exports.DeprecatedAuthenticationCreateValidator = DeprecatedAuthenticationCreateValidator;
//# sourceMappingURL=depricated-authentication-create.validator.js.map