import { ValidationError } from '../../../shared/exceptions/validation.exception';
import { LoggerSharedService } from '../../../shared/logging/logger.shared.service';
export declare class ClassValidator<T> {
    protected readonly loggerService: LoggerSharedService;
    protected readonly entityType: {
        new (): T;
    };
    protected coalesceType: boolean;
    constructor(loggerService: LoggerSharedService, entityType: {
        new (): T;
    }, coalesceType?: boolean);
    validate(obj: Partial<T>, options?: ValidationOptions): Promise<void>;
    tryValidate(obj: Partial<T>, options?: ValidationOptions): Promise<ValidationError | null>;
    protected prepareClassForValidation(obj: Partial<T>): Partial<T>;
}
export declare class ValidationOptions {
    validationGroups?: string[];
    skipMissingProperties?: boolean;
}
//# sourceMappingURL=class-validator.d.ts.map