import { LocalAuthenticateCommand } from '@nestjs-bff/global-contracts/lib/application/auth/local-authenticate.command';
import { LocalRegisterCommand } from '@nestjs-bff/global-contracts/lib/application/auth/local-register.command';
import { AccessPermissionsContract } from '@nestjs-bff/global-contracts/lib/domain/access-permissions/access-permissions.contract';
import { IAuthenticationToken } from '@nestjs-bff/global-contracts/lib/shared/authentication/authentication-token.interface';
import { UserAuthService } from '../../../../application/user-auth/user-auth.service';
import { INestjsBffConfig } from '../../../../config/nestjs-bff.config';
import { FacebookAuthenticationService } from '../../../../domain/authentication/social/facebook-authentication.service';
import { JwtTokenService } from '../../core/jwt/jwt-token.service';
import { BffRequest } from '../../core/types/bff-request.contract';
export declare class AuthController {
    private readonly nestjsBffConfig;
    private readonly authFacebookService;
    private readonly userAuthenticationService;
    private readonly jwtTokenService;
    constructor(nestjsBffConfig: INestjsBffConfig, authFacebookService: FacebookAuthenticationService, userAuthenticationService: UserAuthService, jwtTokenService: JwtTokenService);
    localSignUp(localRegisterCmd: LocalRegisterCommand): Promise<IAuthenticationToken>;
    localSignIn(localAuthenticateCmd: LocalAuthenticateCommand): Promise<IAuthenticationToken>;
    getOauth2UrlForFacebookSignIn(): Promise<{
        redirectUrl: string;
    }>;
    getOauth2UrlForFacebookSignUp(): Promise<{
        redirectUrl: string;
    }>;
    signUpWithFacebook(fbAuthorizationCode: string): Promise<IAuthenticationToken>;
    signInWithFacebook(fbAuthorizationCode: string): Promise<IAuthenticationToken>;
    getAuthorization(req: BffRequest): Promise<{
        accessPermissions?: AccessPermissionsContract;
    }>;
    verificationPublic(): Promise<string>;
    verificationNoAuthorizationDecorator(): Promise<string>;
    verificationRoleProtectedGroupAdmin(): Promise<string>;
    verificationOrganizationProtectedMember(): Promise<string>;
    verificationOrganizationProtectedAdmin(): Promise<string>;
}
//# sourceMappingURL=auth.controller.d.ts.map