"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const local_authenticate_command_1 = require("@nestjs-bff/global-contracts/lib/application/auth/local-authenticate.command");
const local_register_command_1 = require("@nestjs-bff/global-contracts/lib/application/auth/local-register.command");
const roles_constants_1 = require("@nestjs-bff/global-contracts/lib/shared/authorization/roles.constants");
const common_1 = require("@nestjs/common");
const user_auth_service_1 = require("../../../../application/user-auth/user-auth.service");
const facebook_authentication_service_1 = require("../../../../domain/authentication/social/facebook-authentication.service");
const app_shared_constants_1 = require("../../../../shared/app/app.shared.constants");
const org_roles_authcheck_1 = require("../../../../shared/authchecks/org-roles.authcheck");
const role_authcheck_1 = require("../../../../shared/authchecks/role.authcheck");
const authorization_decorator_1 = require("../../core/decorators/authorization.decorator");
const jwt_token_service_1 = require("../../core/jwt/jwt-token.service");
let AuthController = class AuthController {
    constructor(nestjsBffConfig, authFacebookService, userAuthenticationService, jwtTokenService) {
        this.nestjsBffConfig = nestjsBffConfig;
        this.authFacebookService = authFacebookService;
        this.userAuthenticationService = userAuthenticationService;
        this.jwtTokenService = jwtTokenService;
    }
    localSignUp(localRegisterCmd) {
        return __awaiter(this, void 0, void 0, function* () {
            const authenticationEntity = yield this.userAuthenticationService.signUpWithLocal(localRegisterCmd);
            return this.jwtTokenService.createToken(authenticationEntity);
        });
    }
    localSignIn(localAuthenticateCmd) {
        return __awaiter(this, void 0, void 0, function* () {
            const authenticationEntity = yield this.userAuthenticationService.signInWithLocal(localAuthenticateCmd);
            return this.jwtTokenService.createToken(authenticationEntity);
        });
    }
    getOauth2UrlForFacebookSignIn() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.authFacebookService.getOauth2RedirectUrl(`${this.nestjsBffConfig.http.spaRootUrl}${this.nestjsBffConfig.social.facebook.callbackRelativeURL_signIn}`);
        });
    }
    getOauth2UrlForFacebookSignUp() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.authFacebookService.getOauth2RedirectUrl(`${this.nestjsBffConfig.http.spaRootUrl}${this.nestjsBffConfig.social.facebook.callbackRelativeURL_signUp}`);
        });
    }
    signUpWithFacebook(fbAuthorizationCode) {
        return __awaiter(this, void 0, void 0, function* () {
            const authenticationEntity = yield this.userAuthenticationService.signUpWithFacebook(fbAuthorizationCode, this.nestjsBffConfig.http.spaRootUrl);
            return this.jwtTokenService.createToken(authenticationEntity);
        });
    }
    signInWithFacebook(fbAuthorizationCode) {
        return __awaiter(this, void 0, void 0, function* () {
            const authenticationEntity = yield this.userAuthenticationService.signInWithFacebook(fbAuthorizationCode, this.nestjsBffConfig.http.spaRootUrl);
            return this.jwtTokenService.createToken(authenticationEntity);
        });
    }
    getAuthorization(req) {
        return __awaiter(this, void 0, void 0, function* () {
            return { accessPermissions: req.accessPermissions };
        });
    }
    // -- SYSTEM VERIFICATION ENDPOINTS --//
    verificationPublic() {
        return __awaiter(this, void 0, void 0, function* () {
            return 'hit';
        });
    }
    verificationNoAuthorizationDecorator() {
        return __awaiter(this, void 0, void 0, function* () {
            return 'hit';
        });
    }
    verificationRoleProtectedGroupAdmin() {
        return __awaiter(this, void 0, void 0, function* () {
            return 'hit';
        });
    }
    verificationOrganizationProtectedMember() {
        return __awaiter(this, void 0, void 0, function* () {
            return 'hit';
        });
    }
    verificationOrganizationProtectedAdmin() {
        return __awaiter(this, void 0, void 0, function* () {
            return 'hit';
        });
    }
};
__decorate([
    common_1.Post('public/local/signup'),
    __param(0, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [local_register_command_1.LocalRegisterCommand]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "localSignUp", null);
__decorate([
    common_1.Post('public/local/signin'),
    __param(0, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [local_authenticate_command_1.LocalAuthenticateCommand]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "localSignIn", null);
__decorate([
    common_1.Get('public/facebook/oauth2url/sign-in'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "getOauth2UrlForFacebookSignIn", null);
__decorate([
    common_1.Get('public/facebook/oauth2url/sign-up'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "getOauth2UrlForFacebookSignUp", null);
__decorate([
    common_1.Post('public/facebook/signUp'),
    __param(0, common_1.Body('fbAuthorizationCode')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "signUpWithFacebook", null);
__decorate([
    common_1.Post('public/facebook/signin'),
    __param(0, common_1.Body('fbAuthorizationCode')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "signInWithFacebook", null);
__decorate([
    common_1.Get('authorization'),
    __param(0, common_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "getAuthorization", null);
__decorate([
    common_1.Get('public/verification'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "verificationPublic", null);
__decorate([
    common_1.Get('verification/no-authorization-decorator'),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "verificationNoAuthorizationDecorator", null);
__decorate([
    common_1.Get('verification/role-protected-group-admin'),
    authorization_decorator_1.Authorization([new role_authcheck_1.RoleAuthCheck(roles_constants_1.Roles.groupAdmin)]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "verificationRoleProtectedGroupAdmin", null);
__decorate([
    common_1.Get(':organizationSlug/verification/organization-protected-member'),
    authorization_decorator_1.Authorization([new org_roles_authcheck_1.OrgRolesAuthCheck([roles_constants_1.OrganizationRoles.member])]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "verificationOrganizationProtectedMember", null);
__decorate([
    common_1.Get(':organizationSlug/verification/organization-protected-admin'),
    authorization_decorator_1.Authorization([new org_roles_authcheck_1.OrgRolesAuthCheck([roles_constants_1.OrganizationRoles.admin])]),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], AuthController.prototype, "verificationOrganizationProtectedAdmin", null);
AuthController = __decorate([
    common_1.Controller('auth'),
    __param(0, common_1.Inject(app_shared_constants_1.AppSharedProviderTokens.Config.App)),
    __metadata("design:paramtypes", [Object, facebook_authentication_service_1.FacebookAuthenticationService,
        user_auth_service_1.UserAuthService,
        jwt_token_service_1.JwtTokenService])
], AuthController);
exports.AuthController = AuthController;
//# sourceMappingURL=auth.controller.js.map