"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const create_organization_member_command_1 = require("@nestjs-bff/global-contracts/lib/application/auth/create-organization-member.command");
const roles_constants_1 = require("@nestjs-bff/global-contracts/lib/shared/authorization/roles.constants");
const common_1 = require("@nestjs/common");
const organization_orchestration_service_1 = require("../../../../application/organization-orchestration/organization-orchestration.service");
const org_roles_authcheck_1 = require("../../../../shared/authchecks/org-roles.authcheck");
const authorization_decorator_1 = require("../../core/decorators/authorization.decorator");
let OrganizationOrchestrationController = class OrganizationOrchestrationController {
    constructor(organizationService) {
        this.organizationService = organizationService;
    }
    createOrganizationMember(req, cmd) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.organizationService.createMember(cmd, req.accessPermissions);
        });
    }
};
__decorate([
    common_1.Post('create-member'),
    authorization_decorator_1.Authorization([new org_roles_authcheck_1.OrgRolesAuthCheck([roles_constants_1.OrganizationRoles.admin])]),
    __param(0, common_1.Req()), __param(1, common_1.Body()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, create_organization_member_command_1.CreateOrganizationMemberCommand]),
    __metadata("design:returntype", Promise)
], OrganizationOrchestrationController.prototype, "createOrganizationMember", null);
OrganizationOrchestrationController = __decorate([
    common_1.Controller('organization'),
    __metadata("design:paramtypes", [organization_orchestration_service_1.OrganizationOrchestrationService])
], OrganizationOrchestrationController);
exports.OrganizationOrchestrationController = OrganizationOrchestrationController;
//# sourceMappingURL=organization-orchestration.controller.js.map