import { IEntity } from '@nestjs-bff/global-contracts/lib/domain/core/entity.interface';
import { BaseRepo } from '../../../../domain/core/repo/base.repo';
import { BffRequest } from '../types/bff-request.contract';
export declare class DomainControllerBase<TEntity extends IEntity> {
    private readonly entityRepo;
    constructor(entityRepo: BaseRepo<TEntity>);
    getItems(req: BffRequest, body: any): Promise<TEntity[]>;
    getItem(req: BffRequest, id: string): Promise<TEntity>;
    create(req: BffRequest, entity: TEntity): Promise<TEntity>;
    update(req: BffRequest, entity: TEntity): Promise<TEntity>;
    partialUpdate(req: BffRequest, entity: Partial<TEntity>): Promise<TEntity>;
    delete(req: BffRequest, id: any): Promise<TEntity | undefined>;
}
//# sourceMappingURL=domain-controller-base.d.ts.map