"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const access_permissions_module_1 = require("../../../domain/access-permissions/access-permissions.module");
const organization_module_1 = require("../../../domain/organization/organization.module");
const app_shared_module_1 = require("../../../shared/app/app.shared.module");
const caching_shared_module_1 = require("../../../shared/caching/caching.shared.module");
const logging_shared_module_1 = require("../../../shared/logging/logging.shared.module");
const authorization_guard_1 = require("./guards/authorization.guard");
const jwt_token_service_1 = require("./jwt/jwt-token.service");
const attach_authentication_middleware_1 = require("./middleware/attach-authentication.middleware");
let HttpCoreModule = class HttpCoreModule {
};
HttpCoreModule = __decorate([
    common_1.Module({
        imports: [app_shared_module_1.AppSharedModule, access_permissions_module_1.DomainAccessPermissionsModule, organization_module_1.DomainOrganizationModule, logging_shared_module_1.LoggingSharedModule, caching_shared_module_1.CachingSharedModule],
        providers: [authorization_guard_1.AuthorizationGuard, attach_authentication_middleware_1.AttachAuthenticationHttpMiddleware, jwt_token_service_1.JwtTokenService],
        exports: [logging_shared_module_1.LoggingSharedModule, attach_authentication_middleware_1.AttachAuthenticationHttpMiddleware, jwt_token_service_1.JwtTokenService],
    })
], HttpCoreModule);
exports.HttpCoreModule = HttpCoreModule;
//# sourceMappingURL=core.module.js.map