"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
class ServerHttpError extends common_1.HttpException {
    constructor(response, status, metaData) {
        super(response, status);
        this.metaData = metaData;
        Error.captureStackTrace(this, ServerHttpError);
    }
}
class BadGatewayHttpError extends ServerHttpError {
    constructor(response, metaData) {
        super(response, common_1.HttpStatus.BAD_GATEWAY);
        this.metaData = metaData;
    }
}
exports.BadGatewayHttpError = BadGatewayHttpError;
class BadRequestHttpError extends ServerHttpError {
    constructor(response, metaData) {
        super(response, common_1.HttpStatus.BAD_REQUEST);
        this.metaData = metaData;
    }
}
exports.BadRequestHttpError = BadRequestHttpError;
//# sourceMappingURL=server.exception.js.map