import { CanActivate, ExecutionContext } from '@nestjs/common';
import { Reflector } from '@nestjs/core';
import { INestjsBffConfig } from '../../../../config/nestjs-bff.config';
import { OrganizationRepo } from '../../../../domain/organization/repo/organization.repo';
import { CacheStore } from '../../../../shared/caching/cache-store.shared';
import { LoggerSharedService } from '../../../../shared/logging/logger.shared.service';
/**
 *
 *
 * @summary
 *  Checks authorization against a configured authcheck
 *  Defaults false: no authcheck found means no authorization
 *  Looks for authcheck from handler - first on handler method, then on controller
 *
 * @export
 * @class ResourceGuard
 * @implements {CanActivate}
 */
export declare class AuthorizationGuard implements CanActivate {
    private readonly reflector;
    private readonly organizationRepo;
    private readonly cacheStore;
    private readonly nestjsBffConfig;
    private readonly logger;
    constructor(reflector: Reflector, organizationRepo: OrganizationRepo, cacheStore: CacheStore, nestjsBffConfig: INestjsBffConfig, logger: LoggerSharedService);
    canActivate(context: ExecutionContext): Promise<boolean>;
    /**
     *
     * @param organizationSlug
     */
    private getOrgIdFromSlug;
    private getauthchecksFromCache;
    private getauthcheck;
}
//# sourceMappingURL=authorization.guard.d.ts.map