"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const logger_shared_service_1 = require("../../../../shared/logging/logger.shared.service");
let RolesHttpGuard = class RolesHttpGuard {
    constructor(reflector, bffLoggerService) {
        this.reflector = reflector;
        this.bffLoggerService = bffLoggerService;
    }
    canActivate(context) {
        const roles = this.reflector.get('roles', context.getHandler());
        if (!roles) {
            return true;
        }
        const request = context.switchToHttp().getRequest();
        const user = request.user;
        this.bffLoggerService.debug('RolesGuard', user);
        if (!user || !user.roles) {
            return false;
        }
        const hasRole = () => user.roles.some(role => !!roles.find(item => item === role));
        return user && user.roles && hasRole();
    }
};
RolesHttpGuard = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [core_1.Reflector,
        logger_shared_service_1.LoggerSharedService])
], RolesHttpGuard);
exports.RolesHttpGuard = RolesHttpGuard;
//# sourceMappingURL=roles.guard.js.map