import { MiddlewareFunction, NestMiddleware } from '@nestjs/common';
import { INestjsBffConfig } from '../../../../config/nestjs-bff.config';
import { AccessPermissionsRepo } from '../../../../domain/access-permissions/repo/access-permissions.repo';
import { LoggerSharedService } from '../../../../shared/logging/logger.shared.service';
export declare class AttachAuthenticationHttpMiddleware implements NestMiddleware {
    private readonly bffLoggerService;
    private readonly nestjsBffConfig;
    private readonly accessPermissionsRepo;
    private static BEARER_AUTH_SCHEME;
    private static AUTH_HEADER;
    private verifyOptions;
    constructor(bffLoggerService: LoggerSharedService, nestjsBffConfig: INestjsBffConfig, accessPermissionsRepo: AccessPermissionsRepo);
    resolve(context: string): Promise<MiddlewareFunction>;
    private process;
    /**
     *
     *
     * @private
     * @param {*} req
     * @returns {Promise<void>}
     * @memberof JwtMiddleware
     */
    private attachAuthenticatedUserToRequest;
    /**
     *
     *
     * @private
     * @param {*} req
     * @returns {(string | undefined)}
     * @memberof JwtMiddleware
     */
    private getJwtBearerTokenFromRequestHeader;
}
//# sourceMappingURL=attach-authentication.middleware.d.ts.map