"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const migrations_shared_module_1 = require("../../shared/migrations/migrations.shared.module");
const auth_module_1 = require("./application-service-host/auth/auth.module");
const web_app_health_check_module_1 = require("./application-service-host/web-app-health-check/web-app-health-check.module");
const web_app_health_check_service_1 = require("./application-service-host/web-app-health-check/web-app-health-check.service");
const core_module_1 = require("./core/core.module");
const http_exception_filter_1 = require("./core/exceptions/http-exception.filter");
const authorization_guard_1 = require("./core/guards/authorization.guard");
const attach_authentication_middleware_1 = require("./core/middleware/attach-authentication.middleware");
// Order of execution:
// - Middleware
// - Guards
// - Interceptors (before the stream is manipulated)
// - Pipes
// - Interceptors (after the stream is manipulated)
// - Exception filters (if any exception is caught)
const AppFilterProvider = {
    // setting up global filter
    provide: core_1.APP_FILTER,
    useClass: http_exception_filter_1.HttpExceptionFilter,
};
const AppGuardProvider = {
    // setting up global guard
    provide: core_1.APP_GUARD,
    useClass: authorization_guard_1.AuthorizationGuard,
};
const CacheInterceptorProvider = {
    // setting up global caching
    provide: core_1.APP_INTERCEPTOR,
    useClass: common_1.CacheInterceptor,
};
const AppPipeProvider = {
    // setting up global validation and transformation
    provide: core_1.APP_PIPE,
    useFactory: () => new common_1.ValidationPipe({ transform: true }),
};
let HttpWebAppBaseModule = class HttpWebAppBaseModule {
    configure(consumer) {
        consumer.apply(attach_authentication_middleware_1.AttachAuthenticationHttpMiddleware).forRoutes({ path: '*', method: common_1.RequestMethod.ALL });
    }
};
HttpWebAppBaseModule = __decorate([
    common_1.Module({
        imports: [core_module_1.HttpCoreModule, auth_module_1.HttpAuthModule, migrations_shared_module_1.MigrationsSharedModule, web_app_health_check_module_1.WebAppHealthCheckModule],
        controllers: [],
        providers: [web_app_health_check_service_1.WebAppHealthCheckService, AppFilterProvider, CacheInterceptorProvider, AppGuardProvider, AppPipeProvider],
        exports: [],
    })
], HttpWebAppBaseModule);
exports.HttpWebAppBaseModule = HttpWebAppBaseModule;
//# sourceMappingURL=web-app-base.module.js.map