"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const authorization_check_exception_1 = require("../exceptions/authorization-check.exception");
class AuthCheckContract {
    ensureAuthorized(params) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!(yield this.isAuthorized(params))) {
                throw new authorization_check_exception_1.AuthorizationCheckError(params, `Authorization Error in ${this.constructor.name}: `);
            }
        });
    }
}
exports.AuthCheckContract = AuthCheckContract;
//# sourceMappingURL=authcheck.contract.js.map