"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const roles_constants_1 = require("@nestjs-bff/global-contracts/lib/shared/authorization/roles.constants");
function hasRole(requestingEntity, qualifyingRole) {
    return !!requestingEntity.roles && requestingEntity.roles.includes(qualifyingRole);
}
exports.hasRole = hasRole;
function isSystemAdmin(authorization) {
    return authorization.roles.includes(roles_constants_1.Roles.staffAdmin);
}
exports.isSystemAdmin = isSystemAdmin;
function isStaffAdmin(authorization) {
    return authorization.roles.includes(roles_constants_1.Roles.staffAdmin) || authorization.roles.includes(roles_constants_1.Roles.systemAdmin);
}
exports.isStaffAdmin = isStaffAdmin;
function hasOrganization(authorization, organizationIDForResource) {
    return (!!authorization.organizations &&
        !!authorization.organizations.find(organizationAuth => {
            return !!organizationAuth.orgId && organizationAuth.orgId.toString() === organizationIDForResource.toString();
        }));
}
exports.hasOrganization = hasOrganization;
function hasOrganizationRole(accessPermissions, organizationIDForResource, qualifyingRoles) {
    return (!!accessPermissions.organizations &&
        !!accessPermissions.organizations.find(organizationAuth => {
            return (
            // tslint:disable-next-line:triple-equals
            !!organizationAuth.orgId &&
                organizationAuth.orgId.toString() === organizationIDForResource.toString() &&
                qualifyingRoles.some(role => organizationAuth.organizationRoles.includes(role)));
        }));
}
exports.hasOrganizationRole = hasOrganizationRole;
//# sourceMappingURL=authcheck.utils.js.map