"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const authorization_check_exception_1 = require("../exceptions/authorization-check.exception");
const authcheck_contract_1 = require("./authcheck.contract");
const authcheck_utils_1 = require("./authcheck.utils");
class OrgRolesAuthCheck extends authcheck_contract_1.AuthCheckContract {
    constructor(qualifyingRoles) {
        super();
        this.qualifyingRoles = qualifyingRoles;
    }
    isAuthorized(params) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!params.targetResource || !params.targetResource.orgId)
                throw new authorization_check_exception_1.AuthorizationCheckError(params, 'AuthorizationCheckParams - orgId can not be null');
            if (!params.accessPermissions)
                return false;
            if (authcheck_utils_1.isStaffAdmin(params.accessPermissions))
                return true;
            return authcheck_utils_1.hasOrganizationRole(params.accessPermissions, params.targetResource.orgId, this.qualifyingRoles);
        });
    }
}
exports.OrgRolesAuthCheck = OrgRolesAuthCheck;
//# sourceMappingURL=org-roles.authcheck.js.map