"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const roles_constants_1 = require("@nestjs-bff/global-contracts/lib/shared/authorization/roles.constants");
const authcheck_contract_1 = require("./authcheck.contract");
const authcheck_utils_1 = require("./authcheck.utils");
class RoleAuthCheck extends authcheck_contract_1.AuthCheckContract {
    constructor(qualifyingRole) {
        super();
        this.qualifyingRole = qualifyingRole;
        // validation
        if (!Object.keys(roles_constants_1.Roles).includes(qualifyingRole)) {
            throw new Error(`Role ${qualifyingRole} not a valid role`);
        }
    }
    isAuthorized(params) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!params.accessPermissions)
                return false;
            return authcheck_utils_1.hasRole(params.accessPermissions, this.qualifyingRole);
        });
    }
}
exports.RoleAuthCheck = RoleAuthCheck;
//# sourceMappingURL=role.authcheck.js.map