"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const roles_constants_1 = require("@nestjs-bff/global-contracts/lib/shared/authorization/roles.constants");
const authorization_check_exception_1 = require("../exceptions/authorization-check.exception");
const authcheck_contract_1 = require("./authcheck.contract");
const authcheck_utils_1 = require("./authcheck.utils");
class UserAccessAuthCheck extends authcheck_contract_1.AuthCheckContract {
    constructor() {
        super();
    }
    isAuthorized(params) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!params || !params.targetResource || !params.targetResource.userId)
                throw new authorization_check_exception_1.AuthorizationCheckError(params, 'AuthorizationCheckParams - userId can not be null');
            if (!params.accessPermissions)
                return false;
            // if self, then true
            if (params.accessPermissions.userId && params.accessPermissions.userId.toString() === params.targetResource.userId.toString())
                return true;
            // if system admin, then true
            if (authcheck_utils_1.isStaffAdmin(params.accessPermissions))
                return true;
            // if doesn't have orgId, can't verify access through org scope.  Return false
            if (!params.targetResource.orgId)
                return false;
            // if org admin, then true
            return authcheck_utils_1.hasOrganizationRole(params.accessPermissions, params.targetResource.orgId, [roles_constants_1.OrganizationRoles.facilitator, roles_constants_1.OrganizationRoles.admin]);
        });
    }
}
exports.UserAccessAuthCheck = UserAccessAuthCheck;
//# sourceMappingURL=user-access.authcheck.js.map