/**
 * @description: Utility functions to support caching operations
 * @notes:
 *  - Uses json-stable-stringify (instead of JSON.Stringify) for determanistic string generation - regardless of parameter ordering
 *  - Uses custom hash function as significantly faster than cryptogaphic hashes
 */
export declare class CachingUtils {
    private static validator;
    static makeCacheKeyFromId(entityId: string): string;
    static makeCacheKeyFromProperty(propertyName: string, propertyValue: string): string;
    static makeCacheKeyFromObject(object: object): string;
}
//# sourceMappingURL=caching.utils.d.ts.map