"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const app_shared_constants_1 = require("../app/app.shared.constants");
const log_levels_const_1 = require("./log-levels.const");
let LoggerConsoleSharedService = class LoggerConsoleSharedService {
    constructor(nestjsBffConfig) {
        this.nestjsBffConfig = nestjsBffConfig;
        this.startSeparator = '\n';
        this.endSeparator = '\n\n---------------';
        this.logError = this.nestjsBffConfig.logging.console.levels.includes(log_levels_const_1.LogLevels.error);
        this.logWarn = this.nestjsBffConfig.logging.console.levels.includes(log_levels_const_1.LogLevels.warning);
        this.logInfo = this.nestjsBffConfig.logging.console.levels.includes(log_levels_const_1.LogLevels.info);
        this.logDebug = this.nestjsBffConfig.logging.console.levels.includes(log_levels_const_1.LogLevels.debug);
        this.logTrace = this.nestjsBffConfig.logging.console.levels.includes(log_levels_const_1.LogLevels.trace);
    }
    log(msg, ...logObjects) {
        return __awaiter(this, void 0, void 0, function* () {
            // tslint:disable-next-line:no-console
            if (this.logInfo)
                console.log(this.startSeparator, msg, ...logObjects, this.endSeparator);
            // tslint:disable-next-line:no-console
            // console.trace();
        });
    }
    info(msg, ...logObjects) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logInfo) {
                // tslint:disable-next-line:no-console
                console.info(this.startSeparator, msg, ...logObjects, this.endSeparator);
            }
        });
    }
    error(msg, ...logObjects) {
        return __awaiter(this, void 0, void 0, function* () {
            // tslint:disable-next-line:no-console
            if (this.logError) {
                console.error(this.startSeparator, msg, ...logObjects, this.endSeparator);
                // tslint:disable-next-line:no-console
                console.trace();
            }
        });
    }
    warn(msg, ...logObjects) {
        return __awaiter(this, void 0, void 0, function* () {
            // tslint:disable-next-line:no-console
            if (this.logWarn)
                console.warn(this.startSeparator, msg, ...logObjects, this.endSeparator);
        });
    }
    debug(msg, ...logObjects) {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.logDebug) {
                // tslint:disable-next-line:no-console
                console.debug(this.startSeparator, msg, ...logObjects, this.endSeparator);
            }
            // tslint:disable-next-line:no-console
            // console.trace();
        });
    }
    trace(msg, ...logObjects) {
        return __awaiter(this, void 0, void 0, function* () {
            // tslint:disable-next-line:no-console
            if (this.logTrace)
                console.log(this.startSeparator, msg, ...logObjects, this.endSeparator);
        });
    }
};
LoggerConsoleSharedService = __decorate([
    __param(0, common_1.Inject(app_shared_constants_1.AppSharedProviderTokens.Config.App)),
    __metadata("design:paramtypes", [Object])
], LoggerConsoleSharedService);
exports.LoggerConsoleSharedService = LoggerConsoleSharedService;
//# sourceMappingURL=console-logger.shared.service.js.map