"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const mongoose_1 = require("mongoose");
exports.MigrationSchema = new mongoose_1.Schema({
    name: String,
    createdAt: mongoose_1.Schema.Types.Date,
    state: {
        type: mongoose_1.Schema.Types.String,
        enum: ['down', 'up'],
        default: 'down',
    },
}, {
    timestamps: true,
    toJSON: {
        virtuals: true,
        transform: (doc, ret, options) => {
            delete ret.id;
            delete ret.id;
            delete ret.__v;
            return ret;
        },
    },
});
exports.MigrationSchema.virtual('filename').get(function () {
    // @ts-ignore
    return `${this.createdAt.getTime()}-${this.name}.ts`;
});
//# sourceMappingURL=migration.schema.js.map