"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const testing_utils_1 = require("@nestjs-bff/global-utils-dev/lib/testing.utils");
require("jest");
const mongodb_1 = require("mongodb");
//
// Testing Jest capabilities
//
describe('GIVEN an Object with ObjectId types fields', () => {
    it(`should match an equivalent object with string fields after stringifying and parsing`, () => __awaiter(this, void 0, void 0, function* () {
        const o = {
            _id: new mongodb_1.ObjectId('5c36b1295ec9e3fbdc3d1062'),
            name: 'Foo',
            orgId: new mongodb_1.ObjectId('5c36b1295ec9e3fbdc3d1054'),
        };
        const objectToMatch = {
            _id: '5c36b1295ec9e3fbdc3d1062',
            name: 'Foo',
            orgId: '5c36b1295ec9e3fbdc3d1054',
        };
        // convert ObjectIds to Strings
        const os = testing_utils_1.TestingUtils.objectIdsToStrings(o);
        expect(o).not.toMatchObject(objectToMatch);
        expect(os).toMatchObject(objectToMatch);
    }));
});
//# sourceMappingURL=jest.spec.js.map